<template>
  <div>
    <v-row>
      <v-col cols="12" md="6">
        <GLanguageList v-model="value" mode="mandatoryLangCodeISO639_1" />
      </v-col>
      <v-col cols="12" md="6">
        <GLanguageList v-model="value" mode="usedLangCodeISO639_1" />
      </v-col>
    </v-row>
    <v-dialog v-model="dialog" max-width="500">
      <v-card>
        <v-card-title>{{ $t("tool.langPicker.dialogTitle") }}</v-card-title>
        <v-card-text>
          <v-form v-model="valid">
            <GAutocomplete
              v-model="selectedLang"
              i18n="tool.langPicker.language"
              :items="iso639"
              :item-text="(item) => `${item.code} - ${item.name}`"
              item-value="code"
              validate="required"
            />
          </v-form>
        </v-card-text>
        <v-card-actions>
          <v-btn text color="error" @click="$emit('closeDialog')">
            {{ $t("form.cancel") }}
          </v-btn>
          <v-spacer />
          <v-btn
            text
            color="success"
            :disabled="!valid"
            @click="confirmBtnClick"
          >
            {{ $t("form.add") }}
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import { DCCXMLElement } from "@d-ptb/dcc-js";
import GAutocomplete from "@/components/App/Form/gAutocomplete";
import ISO639 from "~/assets/lists/iso-639-codes";
import GLanguageList from "~/components/App/Common/GLanguageList.vue";

export default {
  name: "Language",
  components: { GLanguageList, GAutocomplete },
  props: {
    value: Object,
    dialog: {
      type: Boolean,
    },
    mode: {
      type: String,
    },
  },
  data() {
    return {
      selectedLang: "",
      valid: true,
    };
  },
  computed: {
    iso639Names() {
      const langNames = {};
      ISO639.map((x) => (langNames[x.code] = x.name));
      return langNames;
    },
    iso639() {
      return ISO639;
    },
  },
  methods: {
    confirmBtnClick() {
      this.addLang(this.mode);
      if (this.mode === "mandatoryLangCodeISO639_1")
        this.addLang("usedLangCodeISO639_1");
      this.$emit("closeDialog");
    },
    addLang(lang) {
      if (
        this.value[lang].filter((x) => x._text === this.selectedLang).length ===
        0
      )
        this.value[lang].push(new DCCXMLElement({ _text: this.selectedLang }));
    },
  },
};
</script>
